package de.hdm_stuttgart.mi.sd1.task1;


/**
 * Surrounding a text block by a frame
 */
public class D_Frame {

    /**
     * <p>Surround a sequence of lines by a rectangular text frame.</p>
     *
     * <p>Consider the following example array of text lines:</p>
     *
     * <pre><code class="java">String[] lines = {"This is", "just", "a couple of lines"};</code></pre>
     *
     * <p>Choosing a respective frame character e.g. '*' or '+' these lines will be enclosed by a frame:</p>
     *
     * <table class='goikTableDefaults'>
     *     <caption>Enclosing a text block by a frame.</caption>
     *     <tr>
     *         <th>Frame character <code>'*'</code></th>
     *         <th>Frame character <code>'+'</code></th>
     *     </tr>
     *     <tr>
     *         <td>
     * <pre> *********************
     * * This is           *
     * * just              *
     * * a couple of lines *
     * *********************</pre>
     *         </td>
     *         <td>
     * <pre> +++++++++++++++++++++
     * + This is           +
     * + just              +
     * + a couple of lines +
     * +++++++++++++++++++++</pre>
     *         </td>
     *     </tr>
     * </table>
     *
     * <section class="implementationHints">
     * <h4>Hints:</h4>
     * <ul>
     *     <li>{@link String#repeat(int)}</li>
     *     <li>{@link Character#toString(char)}</li>
     *
     *     <li>Mind "\n" character problems: E.g. appending an unintended final newline to your returned string might
     *     cause all tests to fail despite your solution being basically correct.</li>
     * </ul>
     *
     * </section>
     *
     * @param lines Lines to be printed.
     * @param frameCharacter The character to be used for drawing the frame i.e. '*' or '+'
     * @return A single multiline string representing a frame enclosed output.
     */
    public static String createFrame(final String[] lines, final char frameCharacter){
        return "Not yet implemented"; // TODO: Implement me correctly
    }

    private D_Frame(){/* Ignore me: My sole purpose is suppressing default constructor javadoc generation */}
}
