package de.hdm_stuttgart.mi.sd1.task2;

/**
 * <p>Months of year among with their durations.</p>
 *
 * <section class="implementationHints">
 *   <h2>Note:</h2>
 *   <p>There usually is nothing to be changed or implemented here. You are however allowed to i.e.
 *   supply further attributes or methods if it suits your needs.</p>
 *
 *   <p>This task is being solved by implementing {@link Zodiac#getZodiac(Month, int)}.</p>
 *  </section>
 *
 * <p>Each month's maximum (leap years!) number of days is being reflected by the {@link #numberOfDays}
 *    attribute e.g. January having 31 days.</p>
 */
public enum Month {
    /**
     * Month January.
     */
    JAN(31),
    /**
     * Month February.
     */
    FEB(29),
    /**
     * Month March.
     */
    MAR(31),
    /**
     * Month April.
     */
    APR(30),
    /**
     * Month May.
     */
    MAY(31),
    /**
     * Month June.
     */
    JUN(30),
    /**
     * Month July.
     */
    JUL(31),
    /**
     * Month August.
     */
    AUG(31),
    /**
     * Month September.
     */
    SEP(30),
    /**
     * Month October.
     */
    OCT(31),
    /**
     * Month November.
     */
    NOV(30),
    /**
     * Month December.
     */
    DEC(31);

    /**
     * A month is being supplied its maximum number of days, 29 for February due to leap years.
     * @param numberOfDays Total number of days e.g. 31 for January.
     */
     Month(int numberOfDays) {
        this.numberOfDays = numberOfDays;
    }

    /**
     * <p>Current month's number of days e.g. 31 for January.</p>
     */
    public final int numberOfDays;
}
