package de.hdm_stuttgart.mi.sd1.task2;

/**
 * <p>First class Voodoo content. (To be completed, see {@link #getZodiac(Month, int)})</p>
 *
 * <img src="doc-files/zodiacwheel.svg" alt="Zodiac wheel" width="150">
 * <section class="implementationHints">
 *   <h2>Hint:</h2>
 *
 *   <p>This task requires implementing just {@link #getZodiac(Month, int)}. </p>
 *
 *   <p>Depending on your approach you may want to implement the yet uncompleted and possibly
 *   helpful method {@link #matches(Month, int)} as well.</p>
 *
 *  </section>
 *
 * <p>Faithful astrology evangelists honor the twelve zodiac signs:</p>
 *
 * <table border="1" style="border-collapse: collapse;">
 *     <caption>The 12 zodiac signs</caption>
 *     <tr>
 *         <td>
 *             <p><b>Aquarius (Water Bearer)</b></p>
 *             <p>January 20 – February 18</p>
 *             <img src="doc-files/aquarius.svg" alt="Zodiac »Water Bearer« sign" width="150">
 *         </td>
 *         <td>
 *             <p><b>Pisces (Fish)</b></p>
 *             <p>February 19 – March 20</p>
 *             <img src="doc-files/pisces.svg" alt="Zodiac »Fish« sign" width="150">
 *         </td>
 *         <td>
 *             <p><b>Aries(Ram)</b></p>
 *             <p>March 21 – April 19</p>
 *             <img src="doc-files/aries.svg" alt="Zodiac »Ram« sign" width="150">
 *         </td>
 *         <td>
 *             <p><b>Taurus (Bull)</b></p>
 *             <p>April 20 – May 20</p>
 *             <img src="doc-files/taurus.svg" alt="Zodiac »Bull« sign" width="150">
 *         </td>
 *         <td>
 *             <p><b>Gemini (Twins)</b></p>
 *             <p>May 21 – June 21</p>
 *             <img src="doc-files/gemini.svg" alt="Zodiac »Twins« sign" width="150">
 *         </td>
 *         <td>
 *             <p><b>Cancer (Crab)</b></p>
 *             <p>June 22 – July 22</p>
 *             <img src="doc-files/cancer.svg" alt="Zodiac »Cancer« sign" width="150">
 *         </td>
 *     </tr>
 *     <tr>
 *         <td>
 *             <p><b>Leo (Lion)</b></p>
 *             <p>July 23 – August 22</p>
 *             <img src="doc-files/leo.svg" alt="Zodiac »Lion« sign" width="150">
 *         </td>
 *         <td>
 *             <p><b>Virgo (Virgin)</b></p>
 *             <p>August 23 – September 22</p>
 *             <img src="doc-files/virgo.svg" alt="Zodiac »Virgin« sign" width="150">
 *         </td>
 *         <td>
 *             <p><b>Libra (Balance)</b></p>
 *             <p>September 23 – October 23</p>
 *             <img src="doc-files/libra.svg" alt="Zodiac »Balance« sign" width="150">
 *         </td>
 *         <td>
 *             <p><b>Scorpius (Scorpion)</b></p>
 *             <p>October 24–November 21</p>
 *             <img src="doc-files/scorpius.svg" alt="Zodiac »Scorpion« sign" width="150">
 *         </td>
 *         <td>
 *             <p><b>Sagittarius (Archer)</b></p>
 *             <p>November 22 – December 21</p>
 *             <img src="doc-files/sagittarius.svg" alt="Zodiac »Archer« sign" width="150">
 *         </td>
 *         <td>
 *             <p><b>Capricornus (Goat)</b></p>
 *             <p>December 22 – January 19</p>
 *             <img src="doc-files/capricornus.svg" alt="Zodiac »Goat« sign" width="150">
 *         </td>
 *     </tr>
 * </table>
 *
 * <p>The month and day periods above relate to each zodiac's four attributes:</p>
 * <ul>
 *     <li>{@link #fromMonth}</li>
 *     <li>{@link #fromDay}</li>
 *     <li>{@link #toMonth}</li>
 *     <li>{@link #toDay}</li>
 * </ul>
 *
 */
public enum Zodiac {

    /**
     * <p><img src="doc-files/aquarius.svg" alt="Zodiac »Water Bearer« sign" width="40"> »Aquarius« aka »Water Bearer« .</p>
     */
    Aquarius("Aquarius", Month.JAN, 20, Month.FEB, 18),
    /**
     * <p><img src="doc-files/pisces.svg" alt="Zodiac »Fish« sign" width="40"> »Pisces« aka »Fish«.</p>
     */
    Pisces("Pisces", Month.FEB, 19, Month.MAR, 20),
    /**
     * <p><img src="doc-files/aries.svg" alt="Zodiac »Ram« sign" width="40"> »Aries« aka »Ram«.</p>
     */
    Aries("Aries", Month.MAR, 21, Month.APR, 19),
    /**
     * <p><img src="doc-files/taurus.svg" alt="Zodiac »Bull« sign" width="40"> »Taurus« aka »Bull«.</p>
     */
    Taurus("Taurus", Month.APR,20 , Month.MAY, 20),
    /**
     * <p><img src="doc-files/gemini.svg" alt="Zodiac »Twins« sign" width="40"> »Gemini« aka »Twins«.</p>
     */
    Gemini("Gemini", Month.MAY,21, Month.JUN, 21),
    /**
     * <p><img src="doc-files/cancer.svg" alt="Zodiac »Cancer« sign" width="40"> »Cancer« aka »Crab«.</p>
     */
    Cancer("Cancer", Month.JUN, 22, Month.JUL, 22),
    /**
     * <p><img src="doc-files/leo.svg" alt="Zodiac »Lion« sign" width="40"> »Leo« aka »Lion«.</p>
     */
    Leo("Leo", Month.JUL, 23, Month.AUG, 22),
    /**
     * <p><img src="doc-files/virgo.svg" alt="Zodiac »Virgin« sign" width="40"> »Virgo« aka »Virgin«.</p>
     */
    Virgo("Virgo", Month.AUG, 23, Month.SEP, 22),
    /**
     * <p><img src="doc-files/libra.svg" alt="Zodiac »Balance« sign" width="40"> »Libra« aka »Balance«.</p>
     */
    Libra("Libra", Month.SEP, 23, Month.OCT, 23),
    /**
     * <p><img src="doc-files/scorpius.svg" alt="Zodiac »Scorpion« sign" width="40"> »Scorpius« aka »Scorpion«.</p>
     */
    Scorpius("Scorpius", Month.OCT, 24, Month.NOV, 21),
    /**
     * <p><img src="doc-files/sagittarius.svg" alt="Zodiac »Archer« sign" width="40"> »Sagittarius« aka »Archer«.</p>
     */
    Sagittarius("Sagittarius", Month.NOV, 22, Month.DEC, 21),
    /**
     * <p><img src="doc-files/capricornus.svg" alt="Zodiac »Goat« sign" width="40"> »Capricornus« aka »Goat«.</p>
     */
    Capricornus("Capricornus", Month.DEC, 22, Month.JAN, 19),
    ;

    /**
     * <p>Get zodiac sign matching given month and day. Example:</p>
     *
     * <p> <code class="java">getZodiac(JAN, 23)</code> returns {@link #Aquarius} for covering 20-th of January
     *    till 18-th of February.</p>
     *
     * @param month Desired month.
     * @param day Desired day.
     * @return Zodiac sign corresponding to given day and month.
     *
     */
    static public Zodiac getZodiac(final Month month, final int day) {
        return Aquarius; // TODO: Implement me correctly
    }

    /**
     * Zodiac sign's latin name.
     */
    public final String name;
    /**
     * Zodiac sign's starting month.
     */
    public final Month fromMonth;

    /**
     * Zodiac sign's ending month.
     */
    public final Month toMonth;
    /**
     * Zodiac sign's first inclusive day within {@link #fromMonth}.
     */
    public final int fromDay;
    /**
     * Zodiac sign's last inclusive day within {@link #toMonth}.
     */
    public final int toDay;


    Zodiac(String name, Month fromMonth, int fromDay, final Month toMonth, int toDay) {
        this.name = name;
        this.fromMonth = fromMonth;
        this.fromDay = fromDay;
        this.toMonth = toMonth;
        this.toDay = toDay;
    }

    /**
     * <p>Yet unimplemented helper method. Not strictly required to be implemented but possibly helpful for
     * implementing the {@link #getZodiac(Month, int)} task.</p>
     *
     * <p>Check whether a given day and month matches this zodiac i.e. if month and day belong
     * to the period defined by {@link #fromMonth}/{@link #fromDay} until {@link #toMonth}/{@link #toDay}. </p>
     *
     * @param month The month to be checked
     * @param day The day to be checked
     * @return <code>true</code> if given date falls into this zodiac's time period, <code>false</code> otherwise.
     */
    public boolean matches(Month month, int day) {
        return true; // TODO: Maybe implement me as a helper method for your own solution?
    }

}
