package de.hdm_stuttgart.mi.sd1.task1;

import de.hdm_stuttgart.mi.exam.unitmarking.ExaminationTestDefaults;
import de.hdm_stuttgart.mi.exam.unitmarking.Marking;
import org.junit.Assert;
import org.junit.FixMethodOrder;
import org.junit.Test;
import org.junit.runners.MethodSorters;

import java.util.Arrays;

@FixMethodOrder(MethodSorters.NAME_ASCENDING)
public class C_FinanceTest extends ExaminationTestDefaults {

    @Marking(points = 4)
    @Test
    public void test_100empty() {
        assertBalance(0, new int[]{}, new int[]{});
        assertBalance(1, new int[]{1}, new int[]{});
        assertBalance(-1, new int[]{}, new int[]{1});
    }
    @Marking(points = 6)
    @Test
    public void test_200_single() {
        assertBalance(0, new int[]{3}, new int[]{3});
    }

    @Marking(points = 3)
    @Test
    public void test_300_multi() {
        assertBalance(2, new int[]{3, 5, 2}, new int[]{2, 6});
        assertBalance(1, new int[]{Integer.MAX_VALUE, 2}, new int[]{1, Integer.MAX_VALUE});
        assertBalance(-16, new int[]{1, 2, 3}, new int[]{4, 5, 6, 7});
    }

    private static void assertBalance(final int expected, final int[] revenues, final int[]expenses) {
        final int result = C_Finance.getBalance(revenues, expenses);
        if (result != expected) {
            final String message = String.format(
                    "Expected a balance of %d but got %d instead for revenues=%s and expenses=%s ",
                                     expected,    result,
                                                       Arrays.toString(revenues),
                                                                       Arrays.toString(expenses));
            Assert.fail(message);
        }

    }
}