package de.hdm_stuttgart.mi.sd1.task1;

import de.hdm_stuttgart.mi.exam.unitmarking.ExaminationTestDefaults;
import de.hdm_stuttgart.mi.exam.unitmarking.Marking;
import org.junit.Assert;
import org.junit.FixMethodOrder;
import org.junit.Test;
import org.junit.runners.MethodSorters;

@FixMethodOrder(MethodSorters.NAME_ASCENDING)
public class D_FrameTest extends ExaminationTestDefaults {

    @Test
    @Marking(points = 2)
    public void test_100() {

        assertFrame("""
                §§§§§
                § . §
                §§§§§""",
                new String[]{"."},
                '§');
    }

    @Test
    public void test_300() {
        assertFrame("""
                %%%%%%%
                % One %
                %%%%%%%""",
                new String[]{"One"},
                '%');
    }

    @Test
    public void test_400() {
        assertFrame("""
                xxxxxxxxxxxxxxxx
                x Just another x
                x brick        x
                x in the wall! x
                xxxxxxxxxxxxxxxx""",
                new String[]{"Just another", "brick", "in the wall!"},
                'x');
    }

    @Test
    public void test_500() {
        assertFrame("""
                ++++++++++++++++
                + Just another +
                + brick        +
                + in the wall! +
                ++++++++++++++++""",
                new String[]{"Just another", "brick", "in the wall!"},
                '+');
    }

    @Test
    public void test_600() {
        assertFrame("""
                *********************************
                * If at first you don't succeed *
                * try, try, try again.          *
                * Then quit.                    *
                * There's no use                *
                * being a damn fool about it.   *
                *********************************""",
                new String[]{"If at first you don't succeed", "try, try, try again.",
                        "Then quit.", "There's no use", "being a damn fool about it."},
                '*');

    }

    private static void assertFrame(String expected, String[] lines, char frameCharacter) {

        final String actual = D_Frame.createFrame(lines, frameCharacter);

        if (!expected.equals(actual)) {

            String message = "Expected:\n\"\"\"\n" + expected + "\"\"\"\n\n but got:\n\"\"\"\n" +
                    actual + "\"\"\"\ninstead";

            if (expected.concat("\n").equals(actual)) {
                message += "\nHint: The actual result differs from expected by just an additional newline character!";
            }
            Assert.fail(message);
        }
    }
}
