package de.hdm_stuttgart.mi.sd1.task2;

import de.hdm_stuttgart.mi.exam.unitmarking.ExaminationTestDefaults;
import de.hdm_stuttgart.mi.exam.unitmarking.Marking;
import org.junit.Assert;
import org.junit.FixMethodOrder;
import org.junit.Test;
import org.junit.runners.MethodSorters;

@FixMethodOrder(MethodSorters.NAME_ASCENDING)
public class ZodiacTest extends ExaminationTestDefaults {

    @Test
    @Marking(points = 20)
    public void test() {
        for (final Zodiac zodiac : Zodiac.values()) {
            testZodiac(zodiac);
        }
    }

    static void testZodiac(final Zodiac zodiac) {

        for (int day = zodiac.fromDay; day <= zodiac.fromMonth.numberOfDays; day++) {
            assertZodiac(zodiac, zodiac.fromMonth, day);
        }
        for (int day = 1; day <= zodiac.toDay; day++) {
            assertZodiac(zodiac, zodiac.toMonth, day);
        }
    }

    static void assertZodiac(final Zodiac expected, final Month month, final int day) {
        final Zodiac actual = Zodiac.getZodiac(month, day);
        if (expected != actual) {
            final String message = String.format(
                    "Expected %s, but got %s for month %s and day %d, wanna set a breakpoint?",
                    expected,     actual,       month,       day);
            Assert.assertEquals(message, expected, actual);
        }
    }
}
